// This file is generated by kconfig_compiler from kimpanelconfig.kcfg.
// All changes you do to this file will be lost.
#ifndef KIM_BASESETTINGS_H
#define KIM_BASESETTINGS_H

#include <kimpanelruntime_export.h>

#include <kconfigskeleton.h>
#include <kdebug.h>

#include <QDesktopWidget>
#include <QPoint>
namespace KIM {

class KIMPANELRUNTIME_EXPORT BaseSettings : public KConfigSkeleton
{
  public:
    enum { StatusbarHorizontal, StatusbarVertical, StatusbarMatrix };
    enum { LookupTableHorizontal, LookupTableVertical, LookupTableFixedRows, LookupTableFixedColumns };

    static BaseSettings *self();
    ~BaseSettings();

    /**
      Set Defines your preferred status bar icon size.
    */
    static
    void setPreferIconSize( int v )
    {
      if (v < 16)
      {
        kDebug() << "setPreferIconSize: value " << v << " is less than the minimum value of 16";
        v = 16;
      }

      if (v > 128)
      {
        kDebug() << "setPreferIconSize: value " << v << " is greater than the maximum value of 128";
        v = 128;
      }

      if (!self()->isImmutable( QString::fromLatin1( "PreferIconSize" ) ))
        self()->mPreferIconSize = v;
    }

    /**
      Get Defines your preferred status bar icon size.
    */
    static
    int preferIconSize()
    {
      return self()->mPreferIconSize;
    }

    /**
      Set Properties hidden in status bar
    */
    static
    void setStatusbarHiddenProperties( const QStringList & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "StatusbarHiddenProperties" ) ))
        self()->mStatusbarHiddenProperties = v;
    }

    /**
      Get Properties hidden in status bar
    */
    static
    QStringList statusbarHiddenProperties()
    {
      return self()->mStatusbarHiddenProperties;
    }

    /**
      Set Position of floating status bar
    */
    static
    void setFloatingStatusbarPos( const QPoint & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "FloatingStatusbarPos" ) ))
        self()->mFloatingStatusbarPos = v;
    }

    /**
      Get Position of floating status bar
    */
    static
    QPoint floatingStatusbarPos()
    {
      return self()->mFloatingStatusbarPos;
    }

    /**
      Set Defines how icons are positioned in the floating status bar.
    */
    static
    void setFloatingStatusbarLayout( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "FloatingStatusbarLayout" ) ))
        self()->mFloatingStatusbarLayout = v;
    }

    /**
      Get Defines how icons are positioned in the floating status bar.
    */
    static
    int floatingStatusbarLayout()
    {
      return self()->mFloatingStatusbarLayout;
    }

    /**
      Set Defines the layout of the list of candidate words.
    */
    static
    void setLookupTableLayout( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "LookupTableLayout" ) ))
        self()->mLookupTableLayout = v;
    }

    /**
      Get Defines the layout of the list of candidate words.
    */
    static
    int lookupTableLayout()
    {
      return self()->mLookupTableLayout;
    }

    /**
      Set Restricts the layout of the list of candidate words.
    */
    static
    void setLookupTableConstraint( int v )
    {
      if (v < 1)
      {
        kDebug() << "setLookupTableConstraint: value " << v << " is less than the minimum value of 1";
        v = 1;
      }

      if (v > 9)
      {
        kDebug() << "setLookupTableConstraint: value " << v << " is greater than the maximum value of 9";
        v = 9;
      }

      if (!self()->isImmutable( QString::fromLatin1( "LookupTableConstraint" ) ))
        self()->mLookupTableConstraint = v;
    }

    /**
      Get Restricts the layout of the list of candidate words.
    */
    static
    int lookupTableConstraint()
    {
      return self()->mLookupTableConstraint;
    }

  protected:
    BaseSettings();
    friend class BaseSettingsHelper;


    // Layout
    int mPreferIconSize;
    QStringList mStatusbarHiddenProperties;
    QPoint mFloatingStatusbarPos;
    int mFloatingStatusbarLayout;
    int mLookupTableLayout;
    int mLookupTableConstraint;

  private:
};

}

#endif

